import os
import time

def recover_usb():
    for i in range(20):
        for j in range(20):
            if os.path.exists(f"/sys/bus/usb/devices/{i}-{j}/authorized"):
                os.system(f"echo 0 | sudo tee /sys/bus/usb/devices/{i}-{j}/authorized")
                time.sleep(1)
                os.system(f"echo 1 | sudo tee /sys/bus/usb/devices/{i}-{j}/authorized")

def is_device(deivce: str):
    state: bool = False
    if os.path.exists("/boot/firmware/config.txt"):
        with open("/boot/firmware/config.txt", "r", encoding="utf-8") as f:
            while True:
                line = f.readline()
                if not line:  # 文件结束
                    break
                if line.startswith("dtoverlay=ed-pca953x"):
                    if line.find(f",{deivce}") != -1:
                        return True
    return False

def start():
    if is_device("ipc2110") or is_device("ipc2210"):
        t_num = 0
        t_retry = 0
        while True:
            time.sleep(1)
            if os.path.exists("/sys/class/net/eth1"):
                t_num = 0
                t_retry = 0
            else:
                t_num = t_num + 1
            if t_num > 30:
                if t_retry > 5:
                    print("Try reboot...")
                    os.system("reboot")
                else:
                    print("Try recover usb...")
                    recover_usb()
                    t_retry = t_retry + 1
                    t_num=0

if __name__ == '__main__':
    start()